# Angular Reusable Components

This repository contains the Reusable Components
among the Angular2 web applications.

This project is implemented with [Angular CLI](https://github.com/angular/angular-cli) and executed
via npm scripts.

## Local Binary Dependencies

The following non-npm binaries are required
- node@8.6.0
- npm@5.3.0

If you're using `nvm` you can find a config file in the root.
Additionally, you can use the command `nvm use` to automatically switch

## Local Project Setup

Run `npm install -g @angular/cli` to install the Angular CLI globally.  
Run `npm install` from the project root to install all project dependencies.

## Development Server

Run `ng serve` for a dev server. Navigate to `http://localhost:4200/`. The app will automatically reload if you change any of the source files.

## Generating Components

Run `ng generate component component-name` to generate a new component. You can also use `ng generate directive/pipe/service/class/module`.

## Building

### Development

Run `npm run build` to build the project. The build artifacts will be stored in the `dist/` directory.

### Production

Run `npm run build-production` to build the project in production mode. This includes minimizing, uglifying and running
the showcase app in production mode.

## Running unit tests

Run `npm run test` to execute the linter and unit tests via [Karma](https://karma-runner.github.io) using
[PhantomJS](http://phantomjs.org/)

## Running linters

Run `npm run lint` to execute [tslint](https://github.com/palantir/tslint) and lint the project.

## Code Coverage

Run `npm run coverage` to execute the unit tests plus emit coverage information in the
console as well as in a standalone html project. Coverage files will be created in the `/coverage`
directory.

## Code Documentation
 
Run `npm run docs` to produce jsdocs via [Typedoc](https://github.com/TypeStrong/typedoc).

## Running end-to-end tests

Run `ng e2e` to execute the end-to-end tests via [Protractor](http://www.protractortest.org/).
Before running the tests make sure you are serving the app via `ng serve`.

## Further help

To get more help on the Angular CLI use `ng help` or go check out the [Angular CLI README](https://github.com/angular/angular-cli/blob/master/README.md).
